/*
 *
 * Copyright (c) 2003 GONICUS GmbH.  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Further, this software is distributed without any warranty that it is
 * free of the rightful claim of any third person regarding infringement
 * or the like.  Any license provided herein, whether implied or
 * otherwise, applies only to this software file.  Patent licenses, if
 * any, provided herein do not apply to combinations of this program with
 * other software, or any other product whatsoever.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 * Author:  Holger Burbach <holger.burbach@GONICUS.de>
 *          http://www.GONICUS.de
 *
 */

#ifndef PHP_KADM5_H
#define PHP_KADM5_H

extern zend_module_entry kadm5_module_entry;
#define phpext_kadm5_ptr &kadm5_module_entry

#ifdef PHP_WIN32
#define PHP_KADM5_API __declspec(dllexport)
#else
#define PHP_KADM5_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

PHP_MINIT_FUNCTION(kadm5);
PHP_MSHUTDOWN_FUNCTION(kadm5);
PHP_RINIT_FUNCTION(kadm5);
PHP_RSHUTDOWN_FUNCTION(kadm5);
PHP_MINFO_FUNCTION(kadm5);

PHP_FUNCTION(confirm_kadm5_compiled);	/* For testing, remove later. */
PHP_FUNCTION(kadm5_init_with_password);
PHP_FUNCTION(kadm5_destroy);
PHP_FUNCTION(kadm5_flush);
PHP_FUNCTION(kadm5_create_principal);
PHP_FUNCTION(kadm5_delete_principal);
PHP_FUNCTION(kadm5_modify_principal);
PHP_FUNCTION(kadm5_chpass_principal);
PHP_FUNCTION(kadm5_get_principals);
PHP_FUNCTION(kadm5_get_principal);

PHP_FUNCTION(kadm5_get_policies);


/*
  	Declare any global variables you may need between the BEGIN
	and END macros here:

ZEND_BEGIN_MODULE_GLOBALS(kadm5)
	int   global_value;
	char *global_string;
ZEND_END_MODULE_GLOBALS(kadm5)
*/

/* In every utility function you add that needs to use variables
   in php_kadm5_globals, call TSRM_FETCH(); after declaring other
   variables used by that function, or better yet, pass in TSRMG_CC
   after the last function argument and declare your utility function
   with TSRMG_DC after the last declared argument.  Always refer to
   the globals in your function as KADM5_G(variable).  You are 
   encouraged to rename these macros something shorter, see
   examples in any other php module directory.
*/

#ifdef ZTS
#define KADM5_G(v) TSRMG(kadm5_globals_id, zend_kadm5_globals *, v)
#else
#define KADM5_G(v) (kadm5_globals.v)
#endif

#endif	/* PHP_KADM5_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * indent-tabs-mode: t
 * End:
 */
